(function($) {
	var today = new Date(); // used in defaults
    var months = 'һ,,,,,,,,,ʮ,11,12'.split(',');
	var monthlengths = '31,28,31,30,31,30,31,31,30,31,30,31'.split(',');
  	var dateRegEx = /^\d{1,2}|\d{4}[\/-]\d{1,2}[\/-]\d{2}|\d{4}$/;
	var yearRegEx = /^\d{4,4}$/;
    $.fn.Cal = function(options) {
		var opts = jQuery.extend({}, jQuery.fn.Cal.defaults, options);		
		setupYearRange();		
		function setupYearRange () {			
			var startyear, endyear;  
			if (opts.startdate.constructor == Date) {
				startyear = opts.startdate.getFullYear();
			} else if (opts.startdate) {
				if (yearRegEx.test(opts.startdate)) {
				startyear = opts.startdate;
				} else if (dateRegEx.test(opts.startdate)) {
					opts.startdate = new Date(opts.startdate);
					startyear = opts.startdate.getFullYear();
				} else {
				startyear = today.getFullYear();
				}
			} else {
				startyear = today.getFullYear();
			}
			opts.startyear = startyear;
			
			if (opts.enddate.constructor == Date) {
				endyear = opts.enddate.getFullYear();
			} else if (opts.enddate) {
				if (yearRegEx.test(opts.enddate)) {
					endyear = opts.enddate;
				} else if (dateRegEx.test(opts.enddate)) {
					opts.enddate = new Date(opts.enddate);
					endyear = opts.enddate.getFullYear();
				} else {
					endyear = today.getFullYear();
				}
			} else {
				endyear = today.getFullYear();
			}
			opts.endyear = endyear;	
		}
		
		function newDatepickerHTML () {			
			var years = [];		
			for (var i = 0; i <= opts.endyear - opts.startyear; i ++) years[i] = opts.startyear + i;	
			// build the table structure
			var table = jQuery('<table class="datepicker" cellpadding="0" cellspacing="0"></table>');
			table.append('<thead></thead>');
			table.append('<tfoot></tfoot>');
			table.append('<tbody></tbody>');			
				// month select field
				var monthselect = '<select name="month">';
				for (var i=0,l=months.length;i<l;i++) monthselect += '<option value="'+i+'">'+months[i]+'</option>';
				monthselect += '</select>';			
				// year select field
				var yearselect = '<select name="year">';
				for (var i=0,l=years.length;i<l;i++) yearselect += '<option>'+years[i]+'</option>';
				yearselect += '</select>';
			
			jQuery("thead",table).append('<tr class="controls"><th colspan="7"><span class="prevMonth">&laquo;</span>&nbsp;'+monthselect+yearselect+'&nbsp;<span class="nextMonth">&raquo;</span></th></tr>');
			jQuery("thead",table).append('<tr class="days"><th></th><th>һ</th><th></th><th></th><th></th><th></th><th></th></tr>');
			jQuery("tfoot",table).append('<tr><td colspan="2"><span class="today"></span></td><td colspan="3">&nbsp;</td><td colspan="2"><span class="close">ر</span></td></tr>');
			for (var i = 0; i < 6; i++) jQuery("tbody",table).append('<tr><td></td><td></td><td></td><td></td><td></td><td></td><td></td></tr>');	
			return table;
		}
		
		function findPosition (obj) {
			var curleft = curtop = 0;
			if (obj.offsetParent) {
				do { 
					curleft += obj.offsetLeft;
					curtop += obj.offsetTop;
				} while (obj = obj.offsetParent);
				return [curleft,curtop];
			} else {
				return false;
			}
		}
		function loadMonth (e, el, datepicker, chosendate) {
			

			var mo = jQuery("select[name=month]", datepicker).get(0).selectedIndex;
			var yr = jQuery("select[name=year]", datepicker).get(0).selectedIndex;
			var yrs = jQuery("select[name=year] option", datepicker).get().length;

			if (e && jQuery(e.target).hasClass('prevMonth')) {				
				if (0 == mo && yr) {
					yr -= 1; mo = 11;
					jQuery("select[name=month]", datepicker).get(0).selectedIndex = 11;
					jQuery("select[name=year]", datepicker).get(0).selectedIndex = yr;
				} else {
					mo -= 1;
					jQuery("select[name=month]", datepicker).get(0).selectedIndex = mo;
				}
			} else if (e && jQuery(e.target).hasClass('nextMonth')) {
				if (11 == mo && yr + 1 < yrs) {
					yr += 1; mo = 0;
					jQuery("select[name=month]", datepicker).get(0).selectedIndex = 0;
					jQuery("select[name=year]", datepicker).get(0).selectedIndex = yr;
				} else { 
					mo += 1;
					jQuery("select[name=month]", datepicker).get(0).selectedIndex = mo;
				}
			}

			if (0 == mo && !yr) jQuery("span.prevMonth", datepicker).hide(); 
			else jQuery("span.prevMonth", datepicker).show(); 
			if (yr + 1 == yrs && 11 == mo) jQuery("span.nextMonth", datepicker).hide(); 
			else jQuery("span.nextMonth", datepicker).show(); 
			

			var cells = jQuery("tbody td", datepicker).unbind().empty().removeClass('date');

			var m = jQuery("select[name=month]", datepicker).val();
			var y = jQuery("select[name=year]", datepicker).val();
			var d = new Date(y, m, 1);
			var startindex = d.getDay();
			var numdays = monthlengths[m];
			
			if (1 == m && ((y%4 == 0 && y%100 != 0) || y%400 == 0)) numdays = 29;
			

			if (opts.startdate.constructor == Date) {
				var startMonth = opts.startdate.getMonth();
				var startDate = opts.startdate.getDate();
			}
			if (opts.enddate.constructor == Date) {
				var endMonth = opts.enddate.getMonth();
				var endDate = opts.enddate.getDate();
			}

			for (var i = 0; i < numdays; i++) {
			
				var cell = jQuery(cells.get(i+startindex)).removeClass('chosen');

				if ( 
					(yr || ((!startDate && !startMonth) || ((i+1 >= startDate && mo == startMonth) || mo > startMonth))) &&
					(yr + 1 < yrs || ((!endDate && !endMonth) || ((i+1 <= endDate && mo == endMonth) || mo < endMonth)))) {
				
					cell
						.text(i+1)
						.addClass('date')
						.hover(
							function () { jQuery(this).addClass('over'); },
							function () { jQuery(this).removeClass('over'); })
						.click(function () {
							var chosenDateObj = new Date(jQuery("select[name=year]", datepicker).val(), jQuery("select[name=month]", datepicker).val(), jQuery(this).text());
							closeIt(el, datepicker, chosenDateObj);
						});

					if (i+1 == chosendate.getDate() && m == chosendate.getMonth() && y == chosendate.getFullYear()) cell.addClass('chosen');
				}
			}
		}
		
		function closeIt (el, datepicker, dateObj) { 
			if (dateObj && dateObj.constructor == Date)
				el.val(jQuery.fn.Cal.formatOutput(dateObj));
			datepicker.remove();
			datepicker = null;
			jQuery.data(el.get(0), "Cal", { hasDatepicker : false });
			jQuery(document).unbind('click');
		}

        return this.each(function() {			
			if ( jQuery(this).is('input') && 'text' == jQuery(this).attr('type')) {
				var datepicker; 
				jQuery.data(jQuery(this).get(0), "Cal", { hasDatepicker : false });				

				jQuery(this).click(function (ev) {											 
					var $this = jQuery(ev.target);					
					if (false == jQuery.data($this.get(0), "Cal").hasDatepicker) {
						

						jQuery.data($this.get(0), "Cal", { hasDatepicker : true });
						
						var chosendate,initialDate = $this.val(),d;
						if (initialDate && dateRegEx.test(initialDate)) {
							if(initialDate.indexOf('-')!==-1){
							d=initialDate.split('-');
							chosendate = new Date(parseInt(d[0],10),parseInt(d[1],10)-1,parseInt(d[2],10));
							}else{
								chosendate = new Date(initialDate);
							}
						} else if (opts.chosendate.constructor == Date) {
							chosendate = opts.chosendate;
						} else if (opts.chosendate) {
							chosendate = new Date(opts.chosendate);
						} else {
							chosendate = today;
						}
							
						datepicker = newDatepickerHTML();
						jQuery("body").prepend(datepicker);
						

						var x,y,elPos = findPosition($this.get(0));
						var $datepicker = jQuery(datepicker);
						if((elPos[1]+opts.y+$datepicker.height()) > ($(window).height()-10)){
							y = elPos[1]-$datepicker.height();
						}else{
							y = opts.y + elPos[1];
						}
						x = (parseInt(opts.x) ? parseInt(opts.x) : 0) + elPos[0];
						$datepicker.css({ position: 'absolute', left: x, top: y });
					
						jQuery("span", datepicker).css("cursor","pointer");
						jQuery("select", datepicker).bind('change', function () { loadMonth (null, $this, datepicker, chosendate); });
						jQuery("span.prevMonth", datepicker).click(function (e) { loadMonth (e, $this, datepicker, chosendate); });
						jQuery("span.nextMonth", datepicker).click(function (e) { loadMonth (e, $this, datepicker, chosendate); });
						jQuery("span.today", datepicker).click(function () { closeIt($this, datepicker, new Date()); });
						jQuery("span.close", datepicker).click(function () { closeIt($this, datepicker); });
						
						// set the initial values for the month and year select fields
						// and load the first month
						jQuery("select[name=month]", datepicker).get(0).selectedIndex = chosendate.getMonth();
						jQuery("select[name=year]", datepicker).get(0).selectedIndex = Math.max(0, chosendate.getFullYear() - opts.startyear);
						loadMonth(null, $this, datepicker, chosendate);
							
						jQuery(document).mouseup(function(e){
							var inCal = false,dom = e.target;
							if(dom.tagName.toLowerCase() == 'input' && jQuery(dom).data('Cal')){
								inCal = true;
							}else{
								while(dom.parentNode && typeof dom.parentNode.tagName != 'undefined' && dom.parentNode.tagName.toLowerCase() != 'body'){
									dom = dom.parentNode;
									if(dom.tagName.toLowerCase() == 'table' && $(dom).hasClass('datepicker')){
										inCal = true;
										break;
									}
								}
							}
							if(!inCal){
								closeIt($this, datepicker);
								return false;
							}
						});
					}
					
				});
			}

        });

    };

	jQuery.fn.Cal.formatOutput = function (dateObj) {
		var y = dateObj.getFullYear(),m = (dateObj.getMonth() + 1),d = dateObj.getDate();
		m = m.toString();
		if(m.length == 1){
			m='0'+m;
		}
		d = d.toString();
		if(d.length == 1){
			d='0'+d;
		}
		return y+ '-' + m + '-' + d ;	
	};
	
	jQuery.fn.Cal.defaults = {
		chosendate : today,
		startdate : today.getFullYear()-1, 
		enddate : today.getFullYear(),
		x : 0,
		y : 20 
	};

})(jQuery);