/* This notice must remain at all times.

pie.js
Copyright (c) Balamurugan S, 2005. sbalamurugan @ hotmail.com
Development support by Jexp, Inc http://www.jexp.com 

This package is free software. It is distributed under GPL - legalese removed, it means that you can use this for any purpose, but cannot charge for this software. Any enhancements you make to this piece of code, should be made available free to the general public!

Latest version can be downloaded from http://www.sbmkpm.com

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 

pie.js provides a simple mechanism to draw pie charts. It  uses 
wz_jsgraphics.js  which is copyright of its author.

Usage:
var p = new pie();
p.add("title1",value1);
p.add("title2",value2);

p.render("canvas_name", "graph title");

//where canvas_name is a div defined INSIDE body tag
<body>
<div id="canvas_name" style="overflow: auto; position:relative;height:400px;width:400px;"></div>
*/

hD="0123456789ABCDEF";

function d2h(d) 
{
	var h = hD.substr(d&15,1);
	while(d>15) {d>>=4;h=hD.substr(d&15,1)+h;}
	return h;
}

function h2d(h) 
{
	return parseInt(h,16);
}

function pie()
{
	this.ct = 0;
	this.max    = 0;
	this.data   = new Array();
	this.x_name = new Array();
	this.colors = new Array();
	this.descs  = new Array();
	
	this.add = function(x_name, value, color, desc) {
		this.x_name.push(x_name);  
		this.data.push(parseInt(value,10));
		this.colors.push(color);
		this.descs.push(desc);
		this.max += parseInt(value);
	}

	this.draw = function(canvas, sx, sy, r){
		var jg = new jsGraphics(canvas);
		var hyp = r + 20;
		var arc = 0;
		var percent = 0;
		var start = 0;
		var left = sx + r + 45;
		var top  = 6;

		// shadow
		jg.setColor("#a0a0a0");
		jg.fillArc(sx + 4 - r, sy + 6 - r, r * 2, r * 2, 0, 360);
		for(i = 0; i<this.data.length; i++){
			if (this.max == 0) 
				arc = 0;
			else
				arc = Math.round(this.data[i]/this.max*360);

			if (this.max == 0)
				percent = 0;
			else	
				percent = Math.round(this.data[i]/this.max*100);

			jg.setColor(this.colors[i]);
			if (arc != 0) {
				jg.fillArc(sx - r, sy - r, r*2, r*2, start, start + arc);
				start += arc;
			}

			jg.fillRect(left, top, 12, 12);
			jg.setColor("black");
			if (this.descs[i] == "NULL")
				jg.drawString(this.x_name[i]+" ("+percent+"%"+")",left + 20, top);
			else
				jg.drawString(this.x_name[i]+" ("+this.descs[i]+")",left + 20, top);

			top += 20;
		}

		jg.paint();
	}
}
