#!/bin/sh

FLOWEYE=/usr/ramdisk/bin/floweye
WEB_LOGGER()
{
        local logfile
        local curtime

	if [ -e /usr/ramdisk/datalog/keepme ]; then
        	localfile="/usr/ramdisk/datalog/web_`date +%Y.%m.%d`.log"
	else
        	localfile="${DATAPATH}/web_`date +%Y.%m.%d`.log"
	fi

        curtime=`date +%Y.%m.%d/%H:%M:%S`
        echo "${curtime} ${REMOTE_ADDR} ${CGI_username} $1 $2" >> ${localfile}
}

printf "Content-type: text/html\r\n";
printf "Cache-Control: no-cache\r\n"

# cookie ip user logintime 
if [ "${REQUEST_METHOD}" = "POST" ]; then
	. /etc/PG.conf

	# verify hosts
	if [ -f /etc/pawebhosts ]; then
		yes=0
		for ip in `cat /etc/pawebhosts`
		do
			if [ "${ip}" = "${REMOTE_ADDR}" ]; then
				yes=1
				break
			fi
		done

		if [ ${yes} -eq 0 ]; then
			printf "\r\n"
			echo "<html xmlns:v=\"urn:schemas-microsoft-com:vml\" xmlns:o=\"urn:schemas-microsoft-com:office:office\">"
			echo "<head>"
			echo "<script language=javascript>"
			echo "alert(\"ڰȫãIPַ${REMOTE_ADDR}ϵͳܾʴ!\");"
			echo "</script>"
			echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=gb2312\">"
			echo "<META HTTP-EQUIV=REFRESH CONTENT=\"0;URL=/login/login.htm\">"
			echo "</head>"
			exit 
		fi
	fi

	# Check username and password
	success=0
	for line in `cat ${PGPATH}/admin/.htpasswd`
	do
		name=`echo ${line} | cut -d':' -f1`
		if [ "${name}" = "${CGI_username}" ]; then
			pwd=`echo ${line} | cut -d':' -f2-`
			[ "${pwd}" = "${CGI_password}" ] && success=1
			break
		fi
	done

	if [ ${success} -eq 1 ]; then
		logintime=`date +%s1`
		mkdir -p /usr/ramdisk/weblogin/
		bootime=`${FLOWEYE} sysboot`
		ckinfo="paonline_${CGI_username}_$$_${logintime}"
		ckfile="/usr/ramdisk/weblogin/${ckinfo}"
		echo "ip=${REMOTE_ADDR}" > ${ckfile}
		echo "user=${CGI_username}" >> ${ckfile}
		echo "logintime=`date +%Y.%m.%d/%H:%M:%S`" >> ${ckfile}
		printf "Set-Cookie: pauser_${bootime}=${ckinfo};Path=/;\r\n"
		printf "\r\n"

		WEB_LOGGER "û¼" "user=${CGI_username},ip=${REMOTE_ADDR}"
		errmsg=`${FLOWEYE} logger alert "${CGI_username} login success from ${REMOTE_ADDR}"`

		josrel=`${FLOWEYE} jflow stat | grep jos_release | cut -d'=' -f2`
		if [ ${josrel} -ne 0 ]; then
			for nameval in `${FLOWEYE} key info`
			do
				eval "${nameval}"
			done

			if [ "${oem}" != "" ]; then
				msg=""
				if [ ${leftime} -lt 0 ]; then
					msg="LicenseѾ!"
				else
					leftdays=$((${leftime} / 86400))
					if [ ${leftdays} -le 15 ]; then
						if [ ${leftdays} -eq 0 ]; then
							lefthours=$(((${leftime} - ${leftdays} * 86400) / 3600))
							msg="License${lefthours}Сʱ!"
						else
							msg="License${leftdays}!"
						fi
					fi
				fi

				if [ "${msg}" != "" ]; then
					echo "<html>"
					echo "<head>"
					echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=gb2312\">"
					echo "<META HTTP-EQUIV=REFRESH CONTENT=\"2;URL=/index.htm\">"
					echo "</head>"
					echo "<body>"
					echo "<br><br><br><br><br><br><br><br>"
					echo "<center><b><p style=\"color:#ff0000;font-size:40px\">${msg}</p></b></center>"
					echo "</body>"
					echo "</html>"
					exit 0
				fi
			fi
		fi
					
		main=index.htm
		[ "${CGI_username}" = "pppoeman" ] && main=pppoe.htm
		echo "<html xmlns:v=\"urn:schemas-microsoft-com:vml\" xmlns:o=\"urn:schemas-microsoft-com:office:office\">"
		echo "<head>"
		echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=gb2312\">"
		echo "<META HTTP-EQUIV=REFRESH CONTENT=\"0;URL=/${main}\">"
		echo "</head>"
		echo "</html>"
	else
		errmsg=`${FLOWEYE} logger alert "${CGI_username} login FAIL from ${REMOTE_ADDR}"`
		printf "\r\n"
		echo "<html xmlns:v=\"urn:schemas-microsoft-com:vml\" xmlns:o=\"urn:schemas-microsoft-com:office:office\">"
		echo "<head>"
		echo "<script language=javascript>"
		echo "alert(\"û벻!\");"
		echo "</script>"
		echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=gb2312\">"
		echo "<META HTTP-EQUIV=REFRESH CONTENT=\"0;URL=/login/login.htm\">"
		echo "</head>"
		echo "</html>"
	fi
elif [ "${CGI_pakey}" != "" -a "${CGI_username}" = "admin" ]; then
	keyexist=`${FLOWEYE} cloud list | grep "${CGI_pakey}"`
	if [ "${keyexist}" = "" ]; then
		printf "\r\n"
		echo "<html xmlns:v=\"urn:schemas-microsoft-com:vml\" xmlns:o=\"urn:schemas-microsoft-com:office:office\">"
		echo "<head>"
		echo "<script language=javascript>"
		echo "alert(\"!\");"
		echo "</script>"
		echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=gb2312\">"
		echo "<META HTTP-EQUIV=REFRESH CONTENT=\"0;URL=/login/login.htm\">"
		echo "</head>"
		echo "</html>"
	else
		logintime=`date +%s1`
		mkdir -p /usr/ramdisk/weblogin/
		bootime=`${FLOWEYE} sysboot`
		ckinfo="paonline_${CGI_username}_$$_${logintime}"
		ckfile="/usr/ramdisk/weblogin/${ckinfo}"
		echo "ip=${REMOTE_ADDR}" > ${ckfile}
		echo "user=${CGI_username}" >> ${ckfile}
		echo "logintime=`date +%Y.%m.%d/%H:%M:%S`" >> ${ckfile}
		printf "Set-Cookie: pauser_${bootime}=${ckinfo};Path=/;\r\n"
		printf "\r\n"

		errmsg=`${FLOWEYE} cloud remove key=${CGI_pakey}`

		echo "<html xmlns:v=\"urn:schemas-microsoft-com:vml\" xmlns:o=\"urn:schemas-microsoft-com:office:office\">"
		echo "<head>"
		echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=gb2312\">"
		echo "<META HTTP-EQUIV=REFRESH CONTENT=\"0;URL=/index.htm\">"
		echo "</head>"
		echo "</html>"
	fi
else
	printf "\r\n"
	echo "<html xmlns:v=\"urn:schemas-microsoft-com:vml\" xmlns:o=\"urn:schemas-microsoft-com:office:office\">"
	echo "<head>"
	echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=gb2312\">"
	echo "<META HTTP-EQUIV=REFRESH CONTENT=\"0;URL=/login/index.htm\">"
	echo "</head>"
	echo "</html>"
fi
